#pragma once

/********************************

Class:   COpenGLControl

Purpose: Provides convenient usage
         of OpenGL

********************************/

class COpenGLControl
{
public:
	COpenGLControl() { bGlewInitialized = false; }

	bool InitOpenGL(SDL_Window * a_window, void (*a_InitScene)(void *), void (*a_RenderScene)(void *), void(*a_ReleaseScene)(void *), void * lpParam);
	bool InitSDL2(int iMajorVersion, int iMinorVersion);

	void ResizeOpenGLViewportFull();

	void Render(void * lpParam);
	void ReleaseOpenGLControl(void * lpParam);

	void SwapBuffersM();

private:
	SDL_Window * window;
	SDL_GLContext context;
	bool InitGLEW();

	bool bGlewInitialized;

	void (*InitScene)(void * lpParam), (*RenderScene)(void * lpParam), (*ReleaseScene)(void * lpParam);
};
